-- Test translate_campsite_feature
set client_min_messages to warning;
create extension if not exists pgtap;
reset client_min_messages;

begin;

select plan(14);

set search_path to camper, public;

select has_function('camper', 'translate_campsite_feature', array['integer', 'text', 'text']);
select function_lang_is('camper', 'translate_campsite_feature', array['integer', 'text', 'text'], 'sql');
select function_returns('camper', 'translate_campsite_feature', array['integer', 'text', 'text'], 'void');
select isnt_definer('camper', 'translate_campsite_feature', array['integer', 'text', 'text']);
select volatility_is('camper', 'translate_campsite_feature', array['integer', 'text', 'text'], 'volatile');
select function_privs_are('camper', 'translate_campsite_feature', array['integer', 'text', 'text'], 'guest', array[]::text[]);
select function_privs_are('camper', 'translate_campsite_feature', array['integer', 'text', 'text'], 'employee', array[]::text[]);
select function_privs_are('camper', 'translate_campsite_feature', array['integer', 'text', 'text'], 'admin', array['EXECUTE']);
select function_privs_are('camper', 'translate_campsite_feature', array['integer', 'text', 'text'], 'authenticator', array[]::text[]);


set client_min_messages to warning;
truncate campsite_feature_i18n cascade;
truncate campsite_feature cascade;
truncate campsite cascade;
truncate campsite_type cascade;
truncate media cascade;
truncate media_content cascade;
truncate company cascade;
reset client_min_messages;

insert into company (company_id, business_name, vatin, trade_name, phone, email, web, address, city, province, postal_code, rtc_number, tourist_tax, tourist_tax_max_days, country_code, currency_code, default_lang_tag)
values (1, 'Company 2', 'XX123', '', '555-555-555', 'a@a', '', '', '', '', '', '', 60, 7, 'ES', 'EUR', 'ca')
;

insert into media_content (media_type, bytes)
values ('image/x-xpixmap', 'static char *s[]={"1 1 1 1","a c #ffffff","a"};')
;

insert into media (media_id, company_id, original_filename, content_hash)
values (2, 1, 'cover2.xpm', sha256('static char *s[]={"1 1 1 1","a c #ffffff","a"};'))
;

insert into campsite_type (campsite_type_id, company_id, media_id, name, description, active, max_campers, bookable_nights)
values (3, 1, 2, 'Type A', '<p>A</p>', true, 4, '[1, 7]')
;

insert into campsite (campsite_id, company_id, label, campsite_type_id)
values (4, 1, 'A1', 3)
;

insert into campsite_feature (campsite_feature_id, campsite_id, icon_name, name)
values (5, 4, 'toilet', 'Feature 1')
     , (6, 4, 'toilet', 'Feature 2')
;

insert into campsite_feature_i18n (campsite_feature_id, lang_tag, name)
values (6, 'ca', 'carácter2')
;

select lives_ok(
	$$ select translate_campsite_feature(5, 'ca', 'Carácter 1') $$,
	'Should be able to translate the first feature'
);

select lives_ok(
	$$ select translate_campsite_feature(6, 'es', 'Característica 2') $$,
	'Should be able to translate the second feature'
);

select lives_ok(
	$$ select translate_campsite_feature(6, 'en', '') $$,
	'Should be able to “translate” the second feature with an empty translation'
);

select lives_ok(
	$$ select translate_campsite_feature(6, 'ca', 'Carácter 2') $$,
	'Should be able to overwrite the catalan translation of the second feature'
);

select bag_eq(
	$$ select campsite_feature_id, lang_tag, name from campsite_feature_i18n $$,
	$$ values (5, 'ca', 'Carácter 1')
	        , (6, 'ca', 'Carácter 2')
	        , (6, 'es', 'Característica 2')
	        , (6, 'en', null)
	$$,
	'Should have added and updated all translations.'
);


select *
from finish();

rollback;
